From 73efadafc423c16de02aca13412a144b34b8ed3c Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Wed, 20 Mar 2019 09:18:56 +0100
Subject: [PATCH] gcc: Document -save-temps=objects.

---
 contrib/gcc-4.7/gcc/doc/gcc.1     | 22 ++++++++++++++++++++--
 gnu/usr.bin/cc80/drivers/cc/gcc.1 | 22 ++++++++++++++++++++--
 2 files changed, 40 insertions(+), 4 deletions(-)

diff --git a/contrib/gcc-4.7/gcc/doc/gcc.1 b/contrib/gcc-4.7/gcc/doc/gcc.1
index e387a88de3..a4ca28eed4 100644
--- a/contrib/gcc-4.7/gcc/doc/gcc.1
+++ b/contrib/gcc-4.7/gcc/doc/gcc.1
@@ -132,7 +132,7 @@
 .\" ========================================================================
 .\"
 .IX Title "GCC 1"
-.TH GCC 1 "2014-06-12" "gcc-4.7.4" "GNU"
+.TH GCC 1 "2019-03-20" "gcc-4.7.4" "GNU"
 .\" For nroff, turn off justification.  Always turn off hyphenation; it makes
 .\" way too many mistakes in technical documents.
 .if n .ad l
@@ -369,7 +369,7 @@ in the following sections.
 \&\-print\-multi\-directory  \-print\-multi\-lib  \-print\-multi\-os\-directory 
 \&\-print\-prog\-name=\fR\fIprogram\fR  \fB\-print\-search\-dirs  \-Q 
 \&\-print\-sysroot \-print\-sysroot\-headers\-suffix 
-\&\-save\-temps \-save\-temps=cwd \-save\-temps=obj \-time\fR[\fB=\fR\fIfile\fR]
+\&\-save\-temps \-save\-temps=cwd \-save\-temps=obj \-save\-temps=objects \-time\fR[\fB=\fR\fIfile\fR]
 .IP "\fIOptimization Options\fR" 4
 .IX Item "Optimization Options"
 \&\fB\-falign\-functions[=\fR\fIn\fR\fB] \-falign\-jumps[=\fR\fIn\fR\fB] 
@@ -5370,6 +5370,24 @@ For example:
 would create \fIfoo.i\fR, \fIfoo.s\fR, \fIdir/xbar.i\fR,
 \&\fIdir/xbar.s\fR, \fIdir2/yfoobar.i\fR, \fIdir2/yfoobar.s\fR, and
 \&\fIdir2/yfoobar.o\fR.
+.IP "\fB\-save\-temps=objects\fR" 4
+.IX Item "-save-temps=objects"
+Store the usual \*(L"temporary\*(R" intermediate files permanently.  If the
+\&\fB\-o\fR option is used, the temporary files are based on the
+object file.  If the \fB\-o\fR option is not used, the
+\&\fB\-save\-temps=objects\fR switch behaves like \fB\-save\-temps\fR.
+.Sp
+For example:
+.Sp
+.Vb 3
+\&        gcc \-save\-temps=objects \-c foo.c
+\&        gcc \-save\-temps=objects \-c bar.c \-o dir/xbar.o
+\&        gcc \-save\-temps=objects foobar.c \-o dir2/yfoobar
+.Ve
+.Sp
+would create \fIfoo.o.i\fR, \fIfoo.o.s\fR, \fIdir/xbar.o.i\fR,
+\&\fIdir/xbar.i.s\fR, \fIdir2/yfoobar.o.i\fR, \fIdir2/yfoobar.o.s\fR, and
+\&\fIdir2/yfoobar.o\fR.
 .IP "\fB\-time\fR[\fB=\fR\fIfile\fR]" 4
 .IX Item "-time[=file]"
 Report the \s-1CPU\s0 time taken by each subprocess in the compilation
diff --git a/gnu/usr.bin/cc80/drivers/cc/gcc.1 b/gnu/usr.bin/cc80/drivers/cc/gcc.1
index 7cbea60164..27ea85695b 100644
--- a/gnu/usr.bin/cc80/drivers/cc/gcc.1
+++ b/gnu/usr.bin/cc80/drivers/cc/gcc.1
@@ -129,7 +129,7 @@
 .\" ========================================================================
 .\"
 .IX Title "GCC 1"
-.TH GCC 1 "2018-05-02" "gcc-8.1.0" "GNU"
+.TH GCC 1 "2019-03-20" "gcc-8.1.0" "GNU"
 .\" For nroff, turn off justification.  Always turn off hyphenation; it makes
 .\" way too many mistakes in technical documents.
 .if n .ad l
@@ -597,7 +597,7 @@ in the following sections.
 \&\-print\-multi\-directory  \-print\-multi\-lib  \-print\-multi\-os\-directory 
 \&\-print\-prog\-name=\fR\fIprogram\fR  \fB\-print\-search\-dirs  \-Q 
 \&\-print\-sysroot  \-print\-sysroot\-headers\-suffix 
-\&\-save\-temps  \-save\-temps=cwd  \-save\-temps=obj  \-time\fR[\fB=\fR\fIfile\fR]
+\&\-save\-temps  \-save\-temps=cwd  \-save\-temps=obj  \-save\-temps=objects  \-time\fR[\fB=\fR\fIfile\fR]
 .IP "\fIMachine-Dependent Options\fR" 4
 .IX Item "Machine-Dependent Options"
 \&\fIAArch64 Options\fR
@@ -13767,6 +13767,24 @@ For example:
 creates \fIfoo.i\fR, \fIfoo.s\fR, \fIdir/xbar.i\fR,
 \&\fIdir/xbar.s\fR, \fIdir2/yfoobar.i\fR, \fIdir2/yfoobar.s\fR, and
 \&\fIdir2/yfoobar.o\fR.
+.IP "\fB\-save\-temps=objects\fR" 4
+.IX Item "-save-temps=objects"
+Store the usual \*(L"temporary\*(R" intermediate files permanently.  If the
+\&\fB\-o\fR option is used, the temporary files are based on the
+object file.  If the \fB\-o\fR option is not used, the
+\&\fB\-save\-temps=objects\fR switch behaves like \fB\-save\-temps\fR.
+.Sp
+For example:
+.Sp
+.Vb 3
+\&        gcc \-save\-temps=objects \-c foo.c
+\&        gcc \-save\-temps=objects \-c bar.c \-o dir/xbar.o
+\&        gcc \-save\-temps=objects foobar.c \-o dir2/yfoobar
+.Ve
+.Sp
+creates \fIfoo.o.i\fR, \fIfoo.o.s\fR, \fIdir/xbar.o.i\fR,
+\&\fIdir/xbar.o.s\fR, \fIdir2/yfoobar.o.i\fR, \fIdir2/yfoobar.o.s\fR, and
+\&\fIdir2/yfoobar.o\fR.
 .IP "\fB\-time\fR[\fB=\fR\fIfile\fR]" 4
 .IX Item "-time[=file]"
 Report the \s-1CPU\s0 time taken by each subprocess in the compilation
-- 
2.19.2