From 87ec33d0369b0ce8ca886510d4299a096c919531 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Tue, 23 Jan 2018 21:11:07 +0100
Subject: [PATCH] gnu/lib: Raise WARNS generally to 1 via Makefile.inc.

---
 gnu/lib/Makefile.inc                                     | 1 +
 gnu/lib/gcc47/Makefile.inc                               | 2 ++
 gnu/lib/gcc47/libgcov/Makefile                           | 1 -
 gnu/lib/gcc50/Makefile.inc                               | 2 ++
 gnu/lib/gcc50/libgcov/Makefile                           | 1 -
 gnu/lib/gcc50/libstdcxx/components/libconv_1998/Makefile | 7 +++++--
 gnu/lib/libcryptsetup/Makefile                           | 1 -
 gnu/lib/libdevmapper/Makefile                            | 2 --
 gnu/lib/libluks/Makefile                                 | 1 -
 gnu/lib/liblvm/Makefile                                  | 2 --
 10 files changed, 10 insertions(+), 10 deletions(-)
 create mode 100644 gnu/lib/Makefile.inc

diff --git a/gnu/lib/Makefile.inc b/gnu/lib/Makefile.inc
new file mode 100644
index 0000000000..bd2ede6628
--- /dev/null
+++ b/gnu/lib/Makefile.inc
@@ -0,0 +1 @@
+WARNS?=		1
diff --git a/gnu/lib/gcc47/Makefile.inc b/gnu/lib/gcc47/Makefile.inc
index 4f558e53ea..ca02e110a0 100644
--- a/gnu/lib/gcc47/Makefile.inc
+++ b/gnu/lib/gcc47/Makefile.inc
@@ -45,3 +45,5 @@ CFLAGS+=	-I${CCDIR}/../gmp
 WORLD_CCOPTLEVEL:=	1
 .MAKEFLAGS: WORLD_CCOPTLEVEL=1
 .endif
+
+.include "../Makefile.inc"
diff --git a/gnu/lib/gcc47/libgcov/Makefile b/gnu/lib/gcc47/libgcov/Makefile
index ac8ca10f5f..9d6b8b0a07 100644
--- a/gnu/lib/gcc47/libgcov/Makefile
+++ b/gnu/lib/gcc47/libgcov/Makefile
@@ -1,7 +1,6 @@
 .include "../Makefile.inc"
 
 LIB=		gcov
-WARNS?=1
 
 CFLAGS+=	-I.
 CFLAGS+=	-I${GCCDIR}/libgcc
diff --git a/gnu/lib/gcc50/Makefile.inc b/gnu/lib/gcc50/Makefile.inc
index 77d2549be5..ffed183095 100644
--- a/gnu/lib/gcc50/Makefile.inc
+++ b/gnu/lib/gcc50/Makefile.inc
@@ -30,3 +30,5 @@ CFLAGS+=	-I${GCCDIR}/gcc/config/i386
 CFLAGS+=	-I${CCDIR}/../gmp
 
 .endif
+
+.include "../Makefile.inc"
diff --git a/gnu/lib/gcc50/libgcov/Makefile b/gnu/lib/gcc50/libgcov/Makefile
index e1ef12727e..aeb0fb4a5a 100644
--- a/gnu/lib/gcc50/libgcov/Makefile
+++ b/gnu/lib/gcc50/libgcov/Makefile
@@ -2,7 +2,6 @@
 .PATH: ${GCCDIR}/libgcc
 
 LIB=		gcov
-WARNS?=1
 
 CFLAGS+=	-I.
 CFLAGS+=	-I${GCCDIR}/libgcc
diff --git a/gnu/lib/gcc50/libstdcxx/components/libconv_1998/Makefile b/gnu/lib/gcc50/libstdcxx/components/libconv_1998/Makefile
index 5dadd68634..a88a323db7 100644
--- a/gnu/lib/gcc50/libstdcxx/components/libconv_1998/Makefile
+++ b/gnu/lib/gcc50/libstdcxx/components/libconv_1998/Makefile
@@ -30,7 +30,9 @@ COWG=	messages.x
 GENCC=	atomicity.cc basic_file.cc c++locale.cc
 GENCC+=	${COWD:.x=_members_cow.cc} ${COWG:.x=_members_cow.cc}
 
-FLAGS_GROUPS=		gnu11 cow concept explicit
+FLAGS_GROUPS=		deprecated gnu11 cow concept explicit
+deprecated_FLAGS=	-std=gnu++98 -D_BACKWARD_BACKWARD_WARNING_H
+deprecated_FLAGS_FILES=	strstream.cc
 gnu11_FLAGS=		-std=gnu++11 -fno-implicit-templates
 gnu11_FLAGS_FILES=	locale_init.cc localename.cc
 cow_FLAGS=		-D_GLIBCXX_USE_CXX11_ABI=0 -fimplicit-templates
@@ -41,7 +43,8 @@ parallel_FLAGS=		-D_GLIBCXX_PARALLEL -fno-implicit-templates
 parallel_FLAGS_FILES=	parallel_settings.cc
 explicit_FLAGS=		-fno-implicit-templates
 
-REFERENCED_FILES=	${gnu11_FLAGS_FILES} ${cow_FLAGS_FILES} \
+REFERENCED_FILES=	${deprecated_FLAGS_FILES} \
+			${gnu11_FLAGS_FILES} ${cow_FLAGS_FILES} \
 			${concept_FLAGS_FILES} ${parallel_FLAGS_FILES}
 
 .for F in ${SRCS}
diff --git a/gnu/lib/libcryptsetup/Makefile b/gnu/lib/libcryptsetup/Makefile
index ae9674a8a7..7940faa1d8 100644
--- a/gnu/lib/libcryptsetup/Makefile
+++ b/gnu/lib/libcryptsetup/Makefile
@@ -2,7 +2,6 @@ CRYPTSETUP_DIR=	${.CURDIR}/../../../contrib/cryptsetup
 
 LIB=		cryptsetup
 SHLIB_MAJOR?=	0
-WARNS?=		1
 
 SRCS+=		backends.c libdevmapper.c setup.c utils.c \
 		utils_debug.c
diff --git a/gnu/lib/libdevmapper/Makefile b/gnu/lib/libdevmapper/Makefile
index a7b72f186c..5e6cfffa3a 100644
--- a/gnu/lib/libdevmapper/Makefile
+++ b/gnu/lib/libdevmapper/Makefile
@@ -23,8 +23,6 @@ SRCS+=		bitset.c hash.c list.c libdm-common.c libdm-file.c \
 		dbg_malloc.c pool.c matcher.c parse_rx.c ttree.c \
 		libdm-dragonfly-iface.c libdm_dragonfly.c
 
-WARNS?=		1
-
 .PATH: ${LIBDM_DISTDIR}/
 .PATH: ${LIBDM_DISTDIR}/datastruct
 .PATH: ${LIBDM_DISTDIR}/mm
diff --git a/gnu/lib/libluks/Makefile b/gnu/lib/libluks/Makefile
index 7fadc80efb..4dcac6b202 100644
--- a/gnu/lib/libluks/Makefile
+++ b/gnu/lib/libluks/Makefile
@@ -2,7 +2,6 @@ CRYPTSETUP_DIR=	${.CURDIR}/../../../contrib/cryptsetup
 
 LIB=		luks
 SHLIB_MAJOR?=	0
-WARNS?=		1
 
 SRCS+=		af.c hexprint.c keyencryption.c keymanage.c pbkdf.c random.c
 INCS+=		luks.h
diff --git a/gnu/lib/liblvm/Makefile b/gnu/lib/liblvm/Makefile
index 4d386a1250..38e787c490 100644
--- a/gnu/lib/liblvm/Makefile
+++ b/gnu/lib/liblvm/Makefile
@@ -30,8 +30,6 @@ SRCS+=		activate.c lvmcache.c toolcontext.c config.c btree.c \
 # empty source ("empty for now")
 #SRCS+=	util.c
 
-WARNS?=		1
-
 .PATH:	${LVM2_DISTDIR}/lib/
 .PATH:	${LVM2_DISTDIR}/lib/activate
 .PATH:	${LVM2_DISTDIR}/lib/cache
-- 
2.15.1